# Editing IDB #
The IDB can be edited using the PDIT tool available here: https://www.dropbox.com/s/rz1xxpr6j2qpfa4/Solo_PDIT_v1.1.mdb?dl=0. 

# Version History #

| Change Date | Version | Author | Reason for Change | Description | Affected Structures |
|-------------|---------|--------|-------------------|-------------|---------------------|
| N/A         | v2.26   | DS     | N/A               | Initial version in repo, PFM version of IDB | N/A |
| 30-Apr-2018 | v2.26.1 | LIE    | Incorrect PID     | PID 92 is incorrect for TM(21,6), updated to PID 91, resulting in NEW APID = 1468 (OLD: 1484) | TM(21,6) for SSID 10 - 14 and 20 - 24 |
| 27-Aug-2018 | v2.26.2 | LIE    | Added PIX00919    | TC(237,9) needed to be updated to allow for a parameter to control the QL Spectra algorithm to have it wait for N cycles (wait time is N * QL base integration time) between two integration and TM generation intervals | TC(237,6) and PIX00919 |
| 30-Aug-2018 | v2.26.3 | LIE,NH | Update of TM(21,6)| - Updated TM(21,6) SSID=13,23 to use "Number of energy groups (E)" NIX00258 over "Number of structures (M)" NIX00403 | - TM(21,6) SSID=13,23 |
|             |         |        |                   | - Updated TM(21,6) SSID=11,12,21,22 to use 12 bit pixel sets and 4 bit spare (new NIXG0404 and NIXD0407)  | - TM(21,6) SSID=11,12,21,22  |
| 30-Aug-2018 | v2.26.4 | LIE,NH | Update of TM(21,6), fixes |  - fixed group repeaters for TM(21,6) SSID=11,12,21,22 for repeaters: NIX00399 Number of time samples, NIX00442 Number of pixel sets, P, NIX00258 Number of energy groups, and NIX00259 Number of data elements | - TM(21,6) SSID=11,12,21,22 |
|             |         |        |                   | - minor fix on NIXD0017 to say "E2 (...)" instead of "E1 (...)" | - TM(21,6) SSID=11,12,13,21,22,23 |
|             |         |        |                   | - fixed group repeaters for TM(21,6) SSID=13,23 for repeater: NIX00258 Number of energy groups | - TM(21,6) SSID=13,23 |
| 05-Nov-2018 | v2.26.5 | LIE    | Change to spectrogram structure TM(21,6) | Changed format of energies and repeater (efficiency) | TM(21,6) for sepctrogram (SSID=14,24) |
| 11-Nov-2018 | v2.26.6 | LIE    | Change to spectrogram structure TM(21,6) | fixed an issue with repeaters in spectrogram TM(26,1) SSID=14,24 | TM(21,6) for sepctrogram (SSID=14,24) |
| 15-Jan-2019 | v2.26.7 | LIE    | Change to QL parameters TC(237,9), Updated signed parameter in TC(237,7) | Renamed RBAD to CBAD, widened PIX559 (#592), Updated signed parameter (#594) | TC(237,9) and TC(237,7) |
| 15-Jan-2019 | v2.26.8 | LIE    | Fixed an issue with PIX00559 where the 16bit width was not properly set (was still 4 bit from previous value) | Fixed an issue with PIX00559 where the 16bit width was not properly set (was still 4 bit from previous value) | TC(237,9) and TC(237,7) |
| 17-Jan-2019 | v2.26.9 | LIE    | Added textual calibration value 0x3 for parameter NIX00024 (Unidentified).| - | NIX00024 |
| 30-Jan-2019 | v2.26.10 | DS     | Incorrect handling of fixed values in IDB. | CDF_VALUE fixed values converted from decimal to hexadecimal format. | TC(237,7) |
| 11-Feb-2019 | v2.26.11 | LIE | Minor textual change to PIX00033 | - |  TC(238,5) |
| 12-Feb-2019 | v2.26.11-2 | LIE | v2.26.11 could not be properly read by TSC. This version is a re-export of v2.26.11 that is accepted by TSC | - |  - |
| 19-Feb-2019 | v2.26.12 | LIE | Removed SPID 54269 in accordance with removing TM(5,1) flare status message | - |  TM(5,1) |
| 26-Feb-2019 | v2.26.13 | LIE | Updated description of ZIX36018 to say correctly "Request FDIR parameter" | - | TC(238,18) |
| 18-Mar-2019 | v2.26.14 | LIE | Added FID 48457 (SPID 54343, https://github.com/i4Ds/STIX-FSW/issues/599), Added FID 48455 (SPID 54345, https://github.com/i4Ds/STIX-FSW/issues/538), Added FID 48456 (SPID 54346, https://github.com/i4Ds/STIX-FSW/issues/539). All FIDs are used in TM(1,8). Added FID 21548 (SPID 54344, https://github.com/i4Ds/STIX-FSW/issues/599) used in TM(5,2). | - | - |
| 24-Apr-2019 | v2.26.15 | LIE | Added new FIDs 48047, 48048, 48049, 48050, 48051 with SPIDs 54347, 54348, 54349, 54350, 54351 used in TM(1,8) (https://github.com/i4Ds/STIX-FSW/issues/630). | - | - |
| 01-May-2019 | v2.26.16 | LIE | All but 4 LUTs have been removed from the flight software. TMTC has been updated. LUT TCs have not been removed. Instead, LUT 16 (Sky LUT, new: ZIX37704) was switched with LUT 4 (Total FMI, new: ZIX37716) | - | ZIX37704, ZIX37716 |
| 14-May-2019 | v2.26.17 | LIE | - added new SPID 54352 and EID (0x543F), https://github.com/i4Ds/STIX-FSW/issues/382 | | SPID 54352, EID 0x543F |
| | | | - added new SPID 54353 and EID (0x5440), https://github.com/i4Ds/STIX-FSW/issues/559 | | SPID 54353, EID 0x5440 |
| | | | - added new pixel mask definitions to report back visibility pixel sets (A, B, C, D and total count) (https://github.com/i4Ds/STIX-FSW/issues/546) | | TM(21,6) SSID 13/23 |
| 06-Jun-2019 | v2.26.18 | LIE | Added PIX00920 to specify how to deal with bad blocks in filesystem check, added PIX00920 to ZIX38006 | | PIX00920 and TC(238,6) |
| | | | Updated EID 0x9421 with NIX00489 (https://github.com/i4Ds/STIX-FSW/issues/629) | | |
| | | | Added new FID 48458 and SPID 54354 to respond to timing parameter errors | | SPID 54354 |
| 16-Jun-2019 | v2.26.19 | LIE | Updated IDB with new parameters for file types affecting CIXT0032TC | | CIXT0032TC |
| 18-Jun-2019 | v2.26.20 | LIE | Added FID 48459 and SPID 54355 (https://github.com/i4Ds/STIX-FSW/issues/756)  | | FID 48459 for SPID 54355 |
| | | | Fixed issue from consistency check report. The following parameter were missing a PFC_UNIT: NIXD0024 - 26, 40 - 47, 51, 54 - 57  (https://github.com/i4Ds/STIX-IDB/issues/7) | | NIXD0024 - 26, 40 - 47, 51, 54 - 57 |
| | | | Fixed issue from consistency check report. Fixed problem with ZIX38006 where PIX00031 was overlapping new parameter PIX00920 (https://github.com/i4Ds/STIX-IDB/issues/7)  | | ZIX38006 |
| | | | Fixed issue from consistency check report. Fixed problem with incorrect PCF category for NIX00486/7 (status -> numerical) (https://github.com/i4Ds/STIX-IDB/issues/7)  | | NIX00486/7 |
| | | | Fixed issue from consistency check report. Removed unused SPIDs 54283/4 (https://github.com/i4Ds/STIX-IDB/issues/7)  | | SPIDs 54283/4 |
| | | | Fixed issue from consistency check report. Removed an incorrectly added SPID 45352 (https://github.com/i4Ds/STIX-IDB/issues/7) | | SPID 45352 |
| | | | Fixed issue from consistency check report. SPID 54242 was assigned an incorrect EID. Old: 21568, New: 21556, SPID 54247 was also used with EID 21556, but was not actually in TMTC ICD - removed it. (https://github.com/i4Ds/STIX-IDB/issues/7) | | SPIDs 54247, 54242 |
| | | | Fixed issue from consistency check report. Fixed issue where for SPIDs 54354/5 the NIX00001-3 were not properly configured, also correctly aligned NIX for SPID 54344 (https://github.com/i4Ds/STIX-IDB/issues/7) | | SPIDs 54354/5 |
| | | | Fixed issue from consistency check report. Fixed gap and overlap in parameter NIX00003 for SPID 54345 (https://github.com/i4Ds/STIX-IDB/issues/7) 	| | SPID 54345 |
| | | | Fixed issue from consistency check report. Removed "dangling" SPID 54247, corrected text for YIX54242 (https://github.com/i4Ds/STIX-IDB/issues/7) | | SPID 54247, YIX54242 |
| 20-Jun-2019 | v2.26.21 | LIE | Fixed issue from consistency check report. Removed unreferenced TXF records: CIXT1168TM, CIXT2168TM, CIXT3168TM, CIXT4168TM https://github.com/i4Ds/STIX-IDB/issues/7 | | CIXT1168TM, CIXT2168TM, CIXT3168TM |
| | | | Fixed issue from consistency check report. Fixed an issue with a recycled SSID global that was used differently for SPIDs 54142/3. Added new group and parameters: NIXG0405 (new, replaces NIXG0012): NIXD0016 (replaced) NIXD0442 (new), NIXG0405 (new): NIXD0017 (replaced) NIXD0443 (new), (https://github.com/i4Ds/STIX-IDB/issues/7) | | SPIDs 54142/3 |
| | | | Added new FID 48462 with SPID 54356 "TC(239,2) Invalid number of readouts for averaging" | | SPID 54356 and FID 48462 |
| | | | Added new SPID 54357 with EID 0x5441 to indicate "Test procedure interrupted" https://github.com/i4Ds/STIX-FSW/issues/760 | | SPID 54357 and EID 0x5441 |
| | | | Added new SPID 54358 with EID 0x5442 to indicate "Async memory operation interrupted" https://github.com/i4Ds/STIX-FSW/issues/759 | | SPID 54358 and EID 0x5442 |
| | | | Added contextual information for SpW link error SPID 54246, EID 0x5435 (https://github.com/i4Ds/STIX-FSW/issues/749) | | SPID 54246 and EID 0x5435 |
| 25-Jun-2019 | v2.26.22 | LIE | Added textual calibration for Attenuator NIX00342 (CIXT0342TM) and updated NIX00340 (CIXT0340TM) | | NIX00342 (CIXT0342TM), NIX00340 (CIXT0340TM) |
| 25-Jun-2019 | v2.26.23 | LIE | Minor update to CIXT0340TM | | CIXT0340TM |
| 27-Aug-2019 | v2.26.24 | LIE | Triggered by IDB v2.26.23 review (ASU/ESOC), Nr. 121: for SPID=54126 updated updated VPD_OFFSET = -16 --> -15 of spare bit next to NIXD0013 (GH#11) | | SPID 54126 |
| | | LIE | Triggered by IDB v2.26.23 review (ASU/ESOC), Nr. 124: There are 2 packet names that are duplicated and have 2 different SPIDs (YIX54105, YIX54356) (https://github.com/i4Ds/STIX-IDB/issues/12) | | SPID 54345 and 54357 |
| | | LIE | Triggered by IDB v2.26.23 review (ASU/ESOC), Nr. 126: Re-added CIXT1168TM and merged it with previously removed CIXT2168TM, CIXT3168TM, CIXT4168TM (https://github.com/i4Ds/STIX-IDB/issues/13), removed NIXD0170 | | SPID 54101 and 54102, NIXD0170 |
| | | LIE | Added fields from HW/SW Status 1 to TM(3,25) SID 2 that were not visible | | SPID 54102 |
| | | LIE | Triggered by IDB v2.26.23 review (ASU/ESOC), Nr. 127: Updated the group size for NIX00403 in 54113 and 54117 (https://github.com/i4Ds/STIX-IDB/issues/14) | | SPID 54113 and 54117, NIX00403 |
| 29-Aug-2019 | v2.26.25 | LIE | Adding EID 0x5443 (SPID 54359) and EID 0x5444 (SPID 54360) (https://github.com/i4Ds/STIX-FSW/issues/802) | | SPID 54359 and 54360, EID 0x5443 and 0x5444 |
| 2-Sept-2019 | v2.26.26 | LIE | Fixed update from August 27 on HW/SW Status 1 flag for SPID 54102 (https://github.com/i4Ds/STIX-FSW/issues/362) | | SPID 54102 |
| 3-Sept-2019 | v2.26.27 | LIE | Added new SPID 54361 and 54362 with EID 0x142F and 0x1430 to report back rotating buffer EDAC zeroing status (https://github.com/i4Ds/STIX-FSW/issues/362) | | SPID 54361 and 54362, EID 0x142F and 0x1430 |
| 10-Sept-2019 | v2.26.28 | LIE | Fixed issue with incorrect number assignment in CIXT1168TM | | CIXT1168TM |
| 27-Oct-2019 | v2.26.29 | LIE | Updated TC(20,128) structure in IDB for IIC analysis | | ZIX20128, PIX00391 - PIX00400 |
| 07-Nov-2019 | | | Triggered by IDB v2.26.28 review (ASU/ESOC), Nr. 121: Fixed PCF_GLOB_DET to say: NIXG0042 NIXD0013 1, NIXG0042 NIXD0014 6, NIXG0042 NIXD0015 11 (https://github.com/i4Ds/STIX-IDB/issues/17) | | NIXD0013, NIXD0014, NIXD0015 |
| | | | Triggered by IDB v2.26.28 review (ASU/ESOC), Nr. 128: fixed order of NIX00001 and NIX00002 in YIX54345 (https://github.com/i4Ds/STIX-IDB/issues/18) | | YIX54345, NIX00001, NIX00002 |
| | | | Triggered by IDB v2.26.28 re-view (ASU/ESOC), Nr. 129. In-troduced new groups: NIXG0406 with NIXD0444, NIXG0407 with NIXD0445, NIXG0408 with NIXD0446, NIXG0409 with NIXD0447 (https://github.com/i4Ds/STIX-IDB/issues/19)| | NIXG0406 with NIXD0444, NIXG0407 with NIXD0445, NIXG0408 with NIXD0446, NIXG0409 with NIXD0447 |
| | | | Triggered by IDB v2.26.28 re-view (ASU/ESOC), Nr. 130. Fixed PLF_OFFBI 5->2 for NIXD0168 (https://github.com/i4Ds/STIX-IDB/issues/20) | | NIXD0168 |
| | | | Triggered by IDB v2.26.28 re-view (ASU/ESOC), Nr. 119. Up-dated CIXTS001TM with more sensible entries and simplified synthetic parameter NIXS0001. (https://github.com/i4Ds/STIX-IDB/issues/23)  | | CIXTS001TM, NIXS0001 |
| | | | Triggered by IDB v2.26.28 re-view (ASU/ESOC), Nr. 125: CDF_ELTYPE=A for ZIX37009 checked and all set to CDF_DESCR=’Spare’ (https://github.com/i4Ds/STIX-IDB/issues/25) | | ZIX37009 |
| 21-Jan-2020 | v2.26.30 | LIE | Added new FID 48463 and SPID 54363 to indicate Aspect Bulk Science Data request to be already running (https://github.com/i4Ds/STIX-FSW/issues/877) | FID 48463, SPID 54363, ZIX238010 | ZIX238010 |
| 29-Jan-2020 | | | Triggered by IDB v2.26.28 re-view (ASU/ESOC), Nr. 87: Updated CIXT0401TM calibration (RCR). Simplified states as they can be configured and remapped onboard. (https://github.com/i4Ds/STIX-IDB/issues/21) | | CIXT0401TM |
| 17-Feb-2020 | | | Repurposed EID 0x5440/SPID 54353 (https://github.com/i4Ds/STIX-FSW/issues/348) to be used for bulk science data box processing error | | EID 0x5440/SPID 54353 |
| | | | Added new EID 0x5445 with SPID 54364 to indicate interrupted BSD processing (https://github.com/i4Ds/STIX-FSW/issues/348) | | EID 0x5445/SPID 54364 |
| | | | Added new EID 0x5446 with SPID 54365 to indicate BSD processing failed due to incorrect parameterization of request or TM send error (https://github.com/i4Ds/STIX-FSW/issues/348) | | EID 0x5446/SPID 54365 |
| 24-Feb-2020 | v2.26.31 | LIE | Triggered by IDB v2.26.28 re-view (ASU/ESOC), Nr. 123: Missing calibration curve for NIXD0058 (https://github.com/i4Ds/STIX-IDB/issues/24). Added calibra-tion CIXP0029TM and fixed units. | | CIXP0029TM, NIXD0058 |
| | | | Triggered by IDB v2.26.28 review (ASU/ESOC), Nr. 20: Missing calibration in IDB. Added calibrations CIXP0034TM - CIXP0035TM (https://github.com/i4Ds/STIX-IDB/issues/22) | | CIXP0025TM, CIXP0026TM, CIXP0027TM, CIXP0028TM, CIXP0029TM, CIXP0030TM, CIXP0031TM, CIXP0032TM, CIXP0033TM, NIXD0027, NIXD0028, NIXD0029, NIXD0030, NIXD0050, NIXD0075, NIXD0058 |
| | | | Triggered by IDB v2.26.28 review (ASU/ESOC), Nr. 20: Missing calibration in IDB. Added calibrations CIXP0034TM - CIXP0035TM (https://github.com/i4Ds/STIX-IDB/issues/22) | | NIX00101, NIX00102, NIX00125, NIX00355 |
| | | | Triggered by IDB v2.26.28 review (ASU/ESOC), Nr. 20: Missing calibration in IDB. Added calibrations CIXP0034TM - CIXP0035TM (https://github.com/i4Ds/STIX-IDB/issues/22) | | CIXP0034TM, CIXP0035TM, NIXD0031, NIXD0032, NIXD0035, NIXD0036, NIXD0037 |
| | v2.26.32 | | Triggered by IDB v2.26.28 review (ASU/ESOC), Nr. 20: Missing calibration in IDB. Added calibrations CIXP0036TM - CIXP0037TM (https://github.com/i4Ds/STIX-IDB/issues/22) | | CIXP0036TM, CIXP0037TM, NIXD0048, NIXD0049, NIXD0038, NIXD0039, NIX00078, NIX00079, NIX00080, NIX00081 |
| 07-Apr-2020 | v2.26.33 | LIE | Minor update to housekeeping SID=4 (SPID 54103) to be aligned with TMTC ICD. Modified NIXD0064 to be wider. (https://github.com/i4Ds/STIX-IDB/issues/27) | | SPID 54103, NIXD0064 |
| 25-Apr-2020 | | | Widened time unit parameter for TM(238,1) PIX00079 to be 16 bits (https://github.com/i4Ds/STIX-FSW/issues/912)  | | PIX00079, ZIX38001 |
| 26-Apr-2020 | | | Updated TM(21,6) SID 41 (SPID 54124) and added new NIXD0488 to group NIXG0404 to indicate which bit reduction scheme was used in TC(237,3) (https://github.com/i4Ds/STIX-FSW/issues/910) | | NIXD0488, SPID 54124 |
| | | | Updated TM(21,6) SID 42 (SPID 54125) and added new NIX00490 to indicate what averaging value was used in TC(238,10) (https://github.com/i4Ds/STIX-FSW/issues/883) | | NIX00490, SPID 54125 |
 
# Some Insights #
## OCF and OCP: Monitoring Checks ##
The Monitoring Checks allow to observe a parameter and check if its value is between lower and an upper limit (LVALU and HVALU). Optionally, multiple ranges can be provided, which are selected depending on another parameter RLCHK, for which VALPAR is used do determine the applicable LVALU and HVALU set.

## Generating Diffs ##
1. `git diff --name-status v2.26.28...v2.26.32`
2. Copy-paste to script (use ALT):
3. `git diff v2.26.28...v2.26.32 -- idb/file.dat > idb/file.dat.diff`